# Sisense Forecasting Plugin

**Supported Sisense Version**: 7.2

## Description

The plugin allows adding a regression line to a cartesian charts or trellis widget.
Allowed types: linear, exponential and logarithmic. 

## Installation

1. Download the plugin
2. Extract the `.zip` folder to `C:\Program Files\Sisense\PrismWeb\Plugins` (For Sisense v7.2+ extract to `C:\Program Files\Sisense\app\plugins`)
    - If the folder does not exist, please create it before extracting the `.zip` file.
3. Refresh your dashboard

## Implementation

1. Open a dashboard and create a new widget of type column, line, bar, area, trellis.
2. For every value you add, you can set a regression line by clicking the item menu, choosing the 
regression line menu, and choose the appropriate regression type on the submenu.  

## Configurations
In config.js set "addRegressionAsANewSeries" property to true or false, which stands for adding a regression line
to a series or replacing series with a regression line respectively. It is also possible to choose a color for a 
regression line via "regressionLineColor" property in case of addRegressionAsANewSeries=true. If it is not set, regression line will have the same color as the series it was calculated for. See example:
````````````
{
    "addRegressionAsANewSeries": false,
    "regressionLineColor": "#9bf442"
}
````````````

You can also set regression line to a series using the widget script with the following code:

````````````
widget.on('processresult', function(sender, args) {
        var seriesIndexInMetadataPanel = 0;
	var valuesPanelIndex = _.findIndex(args.widget.metadata.panels,function(e){return e.type=="values"});
        
        args.widget.metadata.panels[valuesPanelIndex].items[seriesIndexInMetadataPanel].regression = true;
        args.widget.metadata.panels[valuesPanelIndex].items[seriesIndexInMetadataPanel].format.color ="#29a2a4";
        args.widget.metadata.panels[valuesPanelIndex].items[seriesIndexInMetadataPanel].regressionType = "linear";
        args.widget.metadata.panels[valuesPanelIndex].items[seriesIndexInMetadataPanel].jaql.title = "regression line";
 });
````````````

Regression has a few design options that can be set:

Name          Type         Description                                                  Default
---------------------------------------------------------------------------------------------------                
type          string      The type of the regression formula,                           "linear"
                          can be linear, exponential or logarithmic
    
color         string      Series color                                                  series color by metadata color

dashStyle     string      the series type:                                              "dash"
                          https://api.highcharts.com/highcharts/series.line.dashStyle
   
name          string      the name of the series - is presented on the legend           "[item title] Regression)"
    
hideInLegend  bool        Enable/ disable regression series on legend                   enabled

lineWidth     number      Width of regression line series                               2

tooltip       object     A configuration object for the tooltip rendering               
                         of each regression series. 
                         http://api.highcharts.com/highcharts#series<line>.tooltip
                         
lineType      string     The type of series                                             'spline'
                         http://api.highcharts.com/highcharts#series<line>.type	

## Notes:
* Supported widgets: column, line, bar, area, trellis.

## Limitations

1. Does not support break by on cartesian charts.
2. Trend line data is not exported to csv.
3. Does not support column type "Stacked" and "Stack 100".